#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
void
kdgetsub(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = dgetsub(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr,
                ap[3].v.ivalu,ap[4].v.ivalu);
    pusher = spush;
}
char    *
dgetsub(os,us,is,n1,n2)
char    *os;
char    *us;
char    *is;    /* string with $1, $n subfields */
NOSIGN     n1;
NOSIGN     n2;
{
    REG     char    *isx = is;
    REG     char    *osx = os;
    REG     char    *usx = us;
	if(n2 < n1)	{
		errmsg("dgetsub <parameter error> n2 (%d) < n1 (%d)\n",
			n2,n1);
		terror(FUBAR);
		}
    *osx = ZERO;
    while(*isx != ZERO)
	if(*isx == ESC && isx[1] == DOL)	{
		isx += 2;
		}
	else
	if(*isx == DOL)	{
			if(isx[1] >= n1 && isx[1] <= n2)	{
				*osx++ = *isx++;
				while(osx < usx && *isx != ZERO)
					if(*isx == ESC && isx[1] == DOL)	isx += 2;
					else
					if(*isx == DOL)						break;
					else								*osx++ = *isx++;
				*osx = ZERO;
				}
			else	{
				isx += 1;
				}
            }
    else    {
		isx += 1;
		}
    *osx = ZERO;
    if(osx >= usx)  {
        errmsg("dgetsub <overflow>\n");
        terror(FUBAR);
        }
    return(os);
}
void
kkgetsub(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = kgetsub(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,
		ap[2].v.ptr,ap[3].v.ptr);
    pusher = spush;
}
char	*
kgetsub(os,us,is,ks)
char    *os;
char    *us;
char    *is;
char    *ks;    /* key string for key=data_string */
{
    REG     char    *isx = is;
    REG     char    *osx = os;
    REG     char    *usx = us;
    REG     char    *ksx = ks;
    REG     int     ksl = strlen(ks);
    *osx = ZERO;
    while(*isx != ZERO) {
    if(*isx == *ksx && strncmp(isx,ksx,ksl) == 0 &&
        isx[ksl] == EQC)    {
            ksx = NULL;
            isx += ksl + 1;
            while(isspace(*isx))    ++isx;
            while(osx < usx && *isx != ZERO)
            if(*isx == ESC && isx[1] == EQC)    {
                *osx++ = *isx++;
                *osx++ = *isx++;
                }
            else
            if(*isx == EQC)     break;
            else                {
                if(isspace(*isx) || ispunct(*isx))  ksx = osx;
                *osx++ = *isx++;
                }
            if(*isx == EQC && ksx)  osx = ksx;
            *osx = ZERO;
        }
    else    isx += 1;
    }
    return(os);
}
/**/
void
ksgetsub(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = sgetsub(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr,
                ap[3].v.ivalu,ap[4].v.ivalu,ap[5].v.ivalu);
    pusher = spush;
}
char    *
sgetsub(os,us,is,cx,f1,f2)
char    *os;    /* output string */
char    *us;    /* upper limit */
char    *is;    /* input string */
int     cx;     /* separation character */
int     f1;
int     f2;
{
    REG     char    *osx = os;
    REG     char    *usx = us;
    REG     char    *isx = is;
    REG     int     nf = 0;
    REG     int     nt = 0;
    *os = ZERO;
    while(isx && *isx != ZERO)  {
        if(nf >= f1 && nf <= f2)    {
        if(nt)  *osx++ = cx;
        nt += 1;
            while(osx < usx && *isx != ZERO)
            if(*isx == ESC && isx[1] == cx) {
                *osx++ = *isx++;
                *osx++ = *isx++;
                }
            else
            if(*isx == cx)  break;
            else            *osx++ = *isx++;
        isx = (*isx == cx) ? (isx + 1) : isx;
        *osx = ZERO;
        }
        else                {
            isx = eindex(isx,cx);
            if(isx) isx += 1;
            else    break;
            }
        nf += 1;
    }
    if(osx >= usx)  {
        errmsg("sgetsub <overflow>\n");
        terror(FUBAR);
        }
    return(os);
}
char    *
eindex(is,cx)
char    *is;
int     cx;
{
    REG     char    *isx = is;
    REG     int     cxx = cx;
    while(*isx != ZERO)
    if(*isx == ESC && isx[1] == cxx)    isx += 2;
    else
    if(*isx == cxx)                     return(isx);
    else                                isx += 1;
    return(NULL);
}
