#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
/*EXTERN*/
extern	KENV	kenv;
extern	int		check;			/* defined in KEYIO/keyio.c */
/*STATIC*/
/**/
int	canquery;
int	canescape = YES;
/*
	STUPID-C:  single byte values combined with "word alignment" in
	TURBOC may (will) screw up.
*/
static	struct	OPTIONS	{
	char	*olbl;
	int		otyp;
	int		*ovar;
	char	*otag;
	int		omin;
	int		omax;
}	ox[]	=	{
 "[no]clear",  't', (int *) &clear,   "nocl", 0, 1,
 "[no]check",  't', (int *) &check,   "noch", 0, 1,
 "[no]escape",  't', (int *) &canescape, "noes", 0, 1,
 "[no]query",  't', (int *) &canquery, "noqu", 0, 1,
 "[no]number",  't', (int *) &nupr,  "nonu", 0, 1,
 "[no]time",   't', (int *) &cantime,  "noti", 0, 1,
 "[no]syn",   't', (int *) &cansyn,  "nosy", 0, 1,
 "[no]echo",   't', (int *) &canecho,  "noec", 0, 1,
#ifndef TEST
 "[no]undo",   't', (int *) &ub.canund, "noun", 0, 1,
#endif
 "[no]prompt",  't', (int *) &pront,  "nopr", 0, 1,
 "[no]editin",  't', (int *) &editin,  "noed", 0, 1,
 "[no]leisure",  't', &kenv.leisur, "nole", 0, 1,
 "fold=",   'v', &kenv.folder, "fold=", 32, 132,
 "ctime=",   'v', &kenv.talarm, "ctime=", 0, 9999,
 "error=",   'v', (int *) &error,  "error=", 0, 9999,
} ;
/**/
static	int		nox = sizeof(ox)/sizeof(struct OPTIONS);
/**/
void
setset(is)      /* "set" command */
char    *is;
{
	clear = kenv.leisur & DA;
	canquery = kenv.leisur & DB;
	while(isspace(*is))	++is;
	if(isnull(is))	prtset(stdout);
	else			varset(is);
	return;
}
void
varset(is)
char	*is;
{
	auto	int		i;
	auto	int		lt;
	for(i = 0; i < nox; i++)	{
		if(strncmp(ox[i].otag,is,lt=strlen(ox[i].otag)) == 0)	{
			*(ox[i].ovar) = atoi(is+lt);
			if(*(ox[i].ovar) > ox[i].omax)	*(ox[i].ovar) = ox[i].omax;
			if(*(ox[i].ovar) < ox[i].omin)	*(ox[i].ovar) = ox[i].omin;
			}
		else
		if(strncmp(ox[i].otag+2,is,2) == 0)	{
			*(ox[i].ovar) = ox[i].omax;
			break;
			}
		else
		if(strncmp(ox[i].otag,is,4) == 0)		{
			*(ox[i].ovar) = ox[i].omin;
			break;
			}
	}
	if(clear)		kenv.leisur |= DA;
	else			kenv.leisur &= ~DA;
	if(canquery)	kenv.leisur |= DB;
	else			kenv.leisur &= ~DB;
	prtset(stdout);
	return;
}
void
prtset(fp)
FILE	*fp;
{
	auto	int		i;
	auto	char	*hsh = "==========";
#ifdef	DEBUG
	fprintf(stderr,"nox = %u\n",nox);
#else	DEBUG
	if(!(kenv.prompt & DA))	return;
	if(kenv.leisur & DA)	scr_cl(stdout);
#endif	DEBUG
	puts(hsh);
	puts("set var     turns on toggle");
	puts("set novar   turns off toggle");
	puts("set var=nnn gives var value nnn");
	puts(hsh);
	for(i = 0; i < nox; i++)	{
	if(ox[i].otyp == 't')	{
		fprintf(fp,"%20.20s ",ox[i].olbl);
		if(*(ox[i].ovar))	fprintf(fp,"on\n");
		else				fprintf(fp,"off\n");
		}
	else
	if(ox[i].otyp == 'v')	{
		fprintf(fp,"%20.20s %d\n",ox[i].olbl,*ox[i].ovar);
		}
	}
}
#ifdef	TEST
KENV		kenv;
int		clear;
int		canquery;
int		check;
int		nupr;
int		cantime;
int		cansyn;
int		canecho;
int		pront;
int		editin;
int		error;
main()
{
	auto	char	ls[BUFSIZ];
	while(putchar('?'),fflush(ls),gets(ls))	{
	if(strncmp(ls,"set",3) == 0) 	setset(ls+3);
	else
	if(strncmp(ls,"q",1) == 0)	exit(0);
	else				puts("\007?????");
	}
}
#endif
