#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"keyproto.h"
/**/
#define		KEYSIZE	16
/**/
extern		KARD	*kd;		/* pointers to cards, field ids */
extern		KBUF	kb;			/* input line and work buffer */
/**/
static		int		fc = '#';	/* flag character */
/**/
lsrdfc(nc)						/* set flag character */
int		nc;
{
	auto	int		pc = fc;
	fc = nc;
	return(pc);
}
char	*
lsrdcd(is,ty,xx)				/* read in sharp format from line */
char	*is;
int		ty;
int		xx;
{
	REG		char	*isx = is;
/*
**	read type not implemented
*/
	if(xx != FUBAR)	dump("lsrdcd");
	clcd();
	while(*isx != ZERO)
	if(*isx == fc)	isx = lsgkey(isx+1,ty,FUBAR);
	else			++isx;
	return(is);
}
char	*
lsgkey(is,ty,xx)
char	*is;
int		ty;
int		xx;
{
	REG		char	*isx = is;
	REG		char	*osx = kb.base;
	REG		char	*usx = kb.bmax;
	REG		int		nk;
	if(xx != FUBAR)	dump("lsgkey");
	while(osx < usx && *isx != ZERO)
	if(isalnum(*isx))	*osx++ = *isx++;
	else				break;
	*osx = ZERO;
	nk = *isx != ZERO ? *isx++ : *isx;
	while(*isx != ZERO && *isx == nk)	++isx;
	nk = iskey(kb.base);
	if(nk < 0)	{
		errmsg("lsgkey <bad key> '%s'\n",kb.base);
		terror(FUBAR);
		}
	return(lsgdata(isx,nk,ty,FUBAR));
}
char	*
lsgdata(is,nk,ty,xx)
char	*is;
int		nk;
int		ty;
int		xx;
{
	REG		char	*isx = is;
	REG		char	*osx = kb.base;
	REG		char	*usx = kb.bmax;
	if(xx != FUBAR)	dump("lsgdata");
	while(osx < usx && *isx != ZERO)
		if(*isx == ESC && isx[1] == fc)	{
				*osx++ = *isx++;
				*osx++ = *isx++;
			}
		else
		if(*isx == fc)	{
				if(isx[1] == fc)	++isx;
				break;
			}
		else
		if(isspace(*isx))	{
				while(isspace(*isx))	++isx;
				if(*isx == fc)			;
				else
				if(*isx == ZERO)		;
				else					*osx++ = ' ';
			}
		else	*osx++ = *isx++;
	*osx = ZERO;
	if(osx > usx)	{
		errmsg("lsgdata <overflow>\n");
		terror(FUBAR);
		}
	if(kd[nk].data)	free_if(kd[nk].data);
	kd[nk].data = strsave(kb.base);
	return(isx);
}
#ifdef	TEST
terror(ty)
{
	abort(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	auto	char	ls[BUFSIZ];
	auto	char	ts[BUFSIZ];
	auto	char	*kfn;
	puts("<sharp test bed>");
	kfn = keysfile(cmdstr(argc,argv,'k',NULL));
	keysread(kfn);
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'!':	system(ls+1);
	when	'+':	rdfile(strcnd(ls+1));
	when	'<':	strcpy(ts,ls+1);
	when	'#':	lsrdcd(ts,NULL,FUBAR);
					wrcd(stdout,'f',56);
	when	'K':	keysread(keysfile(ls+1));
	when	'M':	keysmem(stdout);
	when	'c':	clcd();
	when	'k':	keyslist(stdout);
					break;
	default:		puts("\007?????\007\n");
					break;
	}
	exit(0);
}
rdfile(is)
char	*is;
{
	auto	char	ls[BUFSIZ];
	FILE	*fp = efopen(is,"r");
	if(!fp)	terror(FUBAR);
	while(fgets(ls,BUFSIZ-1,fp))	{
		lsrdcd(ls,NULL,FUBAR);
		wrcd(stdout,'f',56);
		}
	fp = xfclose(fp);
}
#endif
