#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/*EXTERNAL*/
extern		double	atof();
/*STATIC*/
static      char    *msg1 = "<stack overflow>\n";
static      char    *msg2 = "<stack underflow>\n";
/*
*/
#define     SIZMSTACK   64              /* size of math stack */
static  union   MSTACK  {
	int     ic;     /* integer constant */
	int     *xp;    /* integer pointer */
}   ms[SIZMSTACK];
/**/
static  int     sp = 0;                 /* stack strchr */
static  char    *ps;                    /* parse pointer */
/**/
char    *
psget(){return(ps);}        /* return parse pointer */
char    *
psset(is)   				/* set parse pointer */
char	*is;
{
	return(ps=is);
}
spget(){return(sp);}        /* return stack strchr */
spset(spx){return(sp=spx);} /* set stack strchr */
/**/
int *
ippush(xp)              /* push integer pointer */
int     *xp;
{
	if(sp >= SIZMSTACK) {
		errmsg(msg1);
		terror(FUBAR);
		}
	return(ms[sp++].xp = xp);   /* data */
}
int *
ippop()                 /* pop integer pointer */
{
	int		*xp;
	if(sp <= 0)  {
		errmsg(msg2);
		terror(FUBAR);
		}
	xp = ms[--sp].xp;
	return(xp);       /* data */
}
icpush(ic)                  /* push integer constant */
int     ic;
{
	if(sp >= SIZMSTACK) {
		errmsg(msg1);
		terror(FUBAR);
		}
	return(ms[sp++].ic = ic);
}
icpop()
{
	int		ic;
	if(sp <= 0)	{
		errmsg(msg2);
		terror(FUBAR);
		}
	ic = ms[--sp].ic;
	return(ic);
}
xee(nv,is)                          /* evaluate an expression */
char    *is;
{
	auto    int spx = spget();      /* save stack strchr */
	auto    int ret = 0;
	if(isnull(is))  return(0);      /* nothing to do */
	savecmd(is);
	expr1(nv, ps = is);             /* evaluate expression */
	ret = icpop();                  /* get value of expression */
	spset(spx);
	return(ret);                    /* return value of expession */
}
char	*
expr1(nv,is)            			/* evalaute an expression */
char    *is;
{
	REG     char    *isx = is;
	REG		int		loop = BLKSIZ;
	REG		int		nr = 0;
	isx = expr2(nv,isx);
	while(loop-- >= 1)
	switch(*isx) {
	case    '+':    isx = expr2(nv,++isx);
					icpush(icpop() + icpop());
	when    '-':	isx = expr2(nv,++isx);
					nr = icpop();
					icpush(icpop() - nr);
	when    '*':    isx = expr2(nv,++isx);
					icpush((icpop()) * (icpop()));
	when    '/':	isx = expr2(nv,++isx);
					nr = icpop();
					icpush(icpop() / nr);
	when    '%':	isx = expr2(nv,++isx);
					nr = icpop();
					icpush(icpop() % nr);
	when    '&':    if(isx[1] == '&')    ++isx;
					isx = expr2(nv,++isx);
					icpush(icpop() * icpop());
	when    '|':    if(isx[1] == '|')    ++isx;
					isx = expr2(nv,++isx);
					icpush(icpop() * icpop());
	when    '!':    if(isx[1] == '=')    {
						isx = expr2(nv,isx+2);
						if(icpop() != icpop())    icpush(1);
						else                        icpush(0);
						}
					else    {
						isx = expr2(nv,isx+1);
						icpush(!(icpop()));
						}
	when    '=':	isx = expr2(nv,isx += 2);
					if(icpop() == icpop())    	icpush(1);
					else                        icpush(0);
	when    '<':    if(isx[1] == '=')    {
						isx = expr2(nv,isx += 2);
						nr = icpop();
						if(icpop() <= nr)         	icpush(1);
						else                        icpush(0);
					}
					else    {
						isx = expr2(nv,++isx);
						nr = icpop();
						if(icpop() < nr)          	icpush(1);
						else                        icpush(0);
					}
	when    '>':    if(isx[1] == '=')    {
						isx = expr2(nv,isx += 2);
						nr = icpop();
						if(icpop() >= nr)         	icpush(1);
						else                        icpush(0);
					}
					else    {
						isx = expr2(nv,++isx);
						nr = icpop();
						if(icpop() > nr)           icpush(1);
						else                        icpush(0);
					}
	when    '\t':   ++isx;
	when    ' ':    ++isx;
	when    ZERO:
	default:		while(isspace(*isx))	++isx;
					return(isx);
	}
	if(loop <= 0)	{
		errmsg("expr1 <loop> '%s'\n",is);
		terror(FUBAR);
		}
	return(isx);
}
char	*
expr2(nv,is)            /* evaluate tokens; put on stack */
char    *is;
{
	auto    int     *nr;
#ifdef		CANFLOAT
	auto    double   fx;
#else
	auto	int		fx;
#endif
	REG		char	*isx = is;
	while(isspace(*isx)) ++isx;
	switch(*isx) {
	case    '(':    isx = expr1(nv,++isx);
					if(*isx++ != ')')    {
						errmsg("expr2: <paren error> '%s'\n",isx-1);
						terror(FUBAR);
					}
	when    '!':    isx = expr2(nv,++isx);        /* logic reverse */
					if(icpop())		icpush(0);
					else			icpush(1);
	when    '-':    isx = expr2(nv,++isx);        /* unary minus */
					icpush(-icpop());
	when    '?':    
/*
**  varadr does stack push; assignment done here
*/
					varadr(nv,isx);
					isx += 3;
					while(*isx != ZERO && isspace(*isx))	++isx;
					if(*isx == '=' && isx[1] != '=')	{
						nr = ippop();
						isx = expr1(nv,++isx);
						icpush(*nr = icpop());
						return(psset(isx));
					}
					else	{
						nr = ippop();
						icpush(*nr);
						}
					break;
	case    '0':
	case    '1':
	case    '2':
	case    '3':
	case    '4':
	case    '5':
	case    '6':
	case    '7':
	case    '8':
	case    '9':    
#ifdef				CANFLOAT
					fx = atof(isx);
#else
					fx = atoi(isx);
#endif
					while(isdigit(*isx)) ++isx;
					if(*isx == '.')      ++isx;
					while(isdigit(*isx)) ++isx;
					if(isalpha(*isx))
					switch(*isx++)   {
					case    'I':    icpush((int) (fx * x[nv].vs));
					when    'i':    icpush((int) (fx * x[nv].hs));
#ifdef				CANFLOAT
					when    'C':    icpush((int) (fx * x[nv].vs/2.54));
					when    'c':    icpush((int) (fx * x[nv].hs/2.54));
#endif
					when    'A':    ;
					when    'a':    ;
					when    'U':    ;
					when    'u':    ;
					default:        
						errmsg("expr2: <unknown scale> '%c'\n",isx[-1]);
						terror(FUBAR);
					}
					else    icpush((int) fx);
					break;
	case    'm':    
		if(strncmp(isx,"min",3) == 0)   return(psset(minmax(nv,'i',isx+3)));
		else
		if(strncmp(isx,"max",3) == 0)	return(psset(minmax(nv,'a',isx+3)));
		else	{
			errmsg("expr2 <unknown function> '%s'\n",isx);
			terror(FUBAR);
			}
	default:        break;
	}
	while(isspace(*isx)) ++isx;
	return(psset(isx));
}
char	*
minmax(nv,ty,is)
char	*is;
{
	REG		char	*isx = is;
	auto	int		xa;
	auto	int		xb;
	isx = expr1(nv,isx);
	if(*isx++ != ',')    {
		errmsg("minmax <function syntax> '%s'\n",isx-1);
		terror(FUBAR);
		}
	isx = expr2(nv,isx);
	xa = icpop();
	xb = icpop();
	if(ty == 'i')	{
			if(xa < xb)		icpush(xa);
			else			icpush(xb);
			}
	else
	if(ty == 'a')	{
			if(xa > xb)		icpush(xa);
			else			icpush(xb);
			}
	while(isspace(*isx))	++isx;
	return(isx);
}
setvar(nv,is,ty,pv,dv)      /* set variable */
char    *is;
{
	auto    int     nr;
	while(isspace(*is)) ++is;
	switch(*is) {
	case    ZERO:   psset(ps = is);
					return(dv);
	case    'N':
	case    'n':
					while(isalnum(*is)) ++is;
					psset(ps = ++is);
					return(0);
	case    'Y':
	case    'y':
					while(isalnum(*is)) ++is;
					psset(ps = ++is);
					return(1);
	case    '-':    nr = pv - xee(nv,++is);
					ps = psget();
					return(nr);
	case    '+':    nr = pv + xee(nv,++is);
					ps = psget();
					return(nr);
	default:        nr = xee(nv,is);
					ps = psget();
					return(nr);
	}
}
char    *
zzs(nv,is)      /* convert all spaces to ZSP */
char    *is;
{
	REG     char    *isx = is;
	while(*isx != ZERO) 
	if(*isx == ' ')     *isx++ = ZSP;
	else                ++isx;
	return(is);
}
xzs(nv,is)
char    *is;
{
	auto    char    *xp[4];
	savecmd(is);
/*
**  convert spaces to protected spaces
**
**  .zs [function] [string] [name]
*/
	getqs(xp,4,is);
	zzs(nv,xp[1]);
	switch(*xp[0])  {
	case    'E':    fflush(x[nv].ofp);
	case    'e':    fputut(xp[1],stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[2],xp[1],'$');
					break;
	default:
	case    't':    isolate(nv,xp[1],1);
					break;
	}
	savecmd("");
	return(0);
}
xfs(nv,is)      /* format string */
char    *is;
{
	auto    char    *xp[5];
	auto    char    ws[BLKSIZ];
/*
**  .fs [function] [string] [format] [name]
**          0           1       2       3
*/
	savecmd(is);
	getqs(xp,4,is);
	sprintf(ws,xp[2],xp[1]);
	zzs(nv,ws);
	switch(*xp[0])  {
	case    'E':    fflush(x[nv].ofp);
	case    'e':    fputut(ws,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[3],ws,'$');
					break;
	default:
	case    't':    isolate(nv,ws,1);
					break;
	}
	savecmd("");
	return(0);
}
xfv(nv,is)      /* format variable */
char    *is;
{
	auto    char    *xp[5];
	auto    int     *ad;
	auto    char    ws[BLKSIZ];
/*
**  .fv [function] [variable] [format] [string]
**          0       1           2       3
*/
	savecmd(is);
	getqs(xp,5,is);
	varadr(nv,xp[1]);
	ad = ippop();
	sprintf(ws,xp[2],*ad);
	zzs(nv,ws);
	switch(*xp[0])  {
	case    'E':    fflush(x[nv].ofp);
	case    'e':    fputut(ws,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[3],ws,'$');
					break;
	default:
	case    't':    isolate(nv,ws,1);
					break;
	}
	savecmd("");
	return(0);
}
xpv(nv,is)      /* print variables in list */
char    *is;
{
	auto    char    *xp[5];
	auto    char    ws[BLKSIZ];
	savecmd(is);
	getqs(xp,5,is);
/*
**  [ets] string name
**  0       1       2
*/
	zpv(nv,ws,ws+BLKSIZ-1,xp[1]);
	switch(*xp[0])  {
	case    'E':    fflush(x[nv].ofp);
	case    'e':    fputut(ws,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(xp[2],ws,'$');
					break;
	default:        
	case    't':    isolate(nv,ws,1);
					break;
	}
	savecmd("");
	return(0);
}
char	*
zpv(nv,os,us,is)    /* return string with ?xx as char str */
char    *os, *us, *is;
{
	auto    char    vs[16];
	auto    int     *ad;
	REG     char    *usx = us;
	REG     char    *osx = os;
	REG     char    *isx = is;
	while(osx < usx && *isx != ZERO)
	if(*isx == ESC && isx[1] == x[nv].qc)   {
		*osx++ = isx[1];
		isx += 2;
		}
	else
	if(*isx == x[nv].qc)    {
		varadr(nv,isx);
		ad = ippop();
		itos(vs,*ad);
		osx = strkat(osx,usx,vs);
		isx += 3;
		}
	else    {
		*osx++ = *isx++;
	}
	*osx = ZERO;
	if(osx >= usx)  overflow(nv,"zpv",FUBAR);
	return(osx);
}
xif(nv,is)          /* simple ".if" */
char    *is;
{
	auto    int     nr;             /* ret value */
	auto    int     spx = spget();
/**/
	if(x[nv].ie >= 1)   {
		errmsg("xif <uncleared .ie>\n");
		terror(FUBAR);
		}
	is = psset(is);
	xif1(nv,is);
	if(nr = icpop())   	psset(eater(nv,psget(),1));
	else                psset(eater(nv,psget(),0));
	if(spget() > spx)   {
		errmsg("xif <stack grew>\n");
		}
	return(nr);
}
xie(nv,is)          /* if - else ".if" */
char    *is;
{
	auto    int     nr;
/*
**  same as xif except value of condition is saved for
**  expected else
*/
/**/
	nr = icpush(xif(nv,is));
	x[nv].ie += 1;
	return(nr);
}
xel(nv,is)          /* else part of if - else */
char    *is;
{
	auto    int     nr;
/**/
	if(x[nv].ie-- <= 0) {
		errmsg("xel <no '.ie' for '.el'>\n");
		terror(FUBAR);
	}
	psset(is);
	if(nr =  icpop())   psset(eater(nv,psget(),0));
	else                psset(eater(nv,psget(),1));
	return(nr);
}
char	*
xif1(nv,is)         /* evaluate if including built in functions */
char    *is;
{
/*
**  result of test goes on math stack
**  routine returns parse position
*/
	switch(*is) {
	case    'r':    icpush(ra == 1);
					return(psset(++is));
	case    'x':    icpush(ix == 1);
					return(psset(++is));
	case    's':    icpush(sl == 1);
					return(psset(++is));
	case    'F':    icpush(x[nv].no == 'f');
					return(psset(++is));
	case    'E':    icpush(x[nv].no == 'e');
					return(psset(++is));
	case    'e':    icpush(x[nv].cp % 2 == 0);
					return(psset(++is));
	case    'o':    icpush(x[nv].cp % 2 >= 1);
					return(psset(++is));
	case    'k':    icpush(1);
					return(psset(++is));
	case    'n':
	case    't':    icpush(0);
					return(psset(++is));
	case    '!':    xif1(0,++is);
					icpush(!icpop());
					return(psget());
	case    '\'':
	case    '"':    icpush(string(is));
					return(psget());
	default:        return(expr1(nv,is));
	}
}
string(is)          /* if test string compare */
char    *is;
{
	auto    char    pc;
	auto    char    s1[BLKSIZ/4];
	auto    char    s2[BLKSIZ/4];
	pc = *is++;
	is = xgnc(s1,&s1[BLKSIZ/4-1],is,pc);
	is = xgnc(s2,&s2[BLKSIZ/4-1],is,pc);
	while(isspace(*is)) ++is;
	psset(is);
	return(strcmp(s1,s2) == 0);
}
