#define		DEBUG
#undef		DEBUG
#include	"pdtar.h"
#include	"pdproto.h"
/*GLOBAL*/
/*LOCAL*/
/*EXTERN*/
notfound()
{
/*
	lfp records files wanted (if given)
	xfp records files accepted for extraction (if any)
	for each item in lfp, check that something in xfp matchs
*/
	auto	char	*ls = f_name;	/* recycle */
	auto	char	*xs = l_name;	/* recycle */
	auto	int		found;
	auto	int		fcnt = 0;
	rewind(lfp);
	while(fgets(ls,NAMSIZ-1,lfp))		{
		strcnd(ls);
		rewind(xfp);
		found = 0;
		while(found == 0 && fgets(xs,NAMSIZ-1,xfp))	{
			if(samename(xs,ls))	found = 1;
			}
		if(!found)	{
			fprintf(stdrpt,"<no match> '%s'\n",ls);
			}
		else	fcnt += 1;
		}
	return(fcnt);	/* what good is this? */
}
arcgener(f_name,phstat)		/* is archive newer */
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "arcgener";
	static	char	g_name[NAMSIZ];
	auto	STAT	lstat;
	auto	char	*eop = NULL;
	auto	char	*dot = NULL;
	auto	int		gen = 0;
/**/
	if(device.extno >= 2)	{	/* use previously created name */
		strcpy(f_name,g_name);
		return(1);
		}
/**/
	if(access(f_name,0))			return(1);	/* no local */
	if(badstat(f_name,&lstat,here))	return(1);
/**/
	if(lstat.st_mtime == phstat->st_mtime &&
		lstat.st_size == phstat->st_size)	return(0);
/**/
	strcpy(l_name,f_name);
/**/
	eop = strrchr(l_name,'/');
	if(eop == NULL)	eop = l_name;
	else			eop += 1;
	eop[8] = ZERO;
	dot = strrchr(eop,'.');
	if(dot == NULL)	dot = eop + strlen(eop);
/**/
	while(1)	{
		sprintf(dot,".%03d",gen);
		if(stat(l_name,&lstat) == 0)	{
			if(lstat.st_mtime == phstat->st_mtime &&
				lstat.st_size == phstat->st_size)	return(0);
			}
		else 	break;
		gen += 1;
		}
/**/
	strcpy(f_name,l_name);
/**/
	strcpy(g_name,f_name);	/* save for extents */
/**/
	return(1);
}
arcnewer(f_name,phstat)		/* is archive newer */
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "arcnewer";
	auto	STAT	lstat;
	if(access(f_name,0))			return(1);	/* no local */
	if(badstat(f_name,&lstat,here))	return(1);
	if(phstat->st_mtime > lstat.st_mtime)	return(1);
	else									return(0);
}
accept(f_name,phstat)	/* do we want this file */
char	*f_name;
STAT	*phstat;
{
	static	char	*here = "accept";
	auto	char	ls[NAMSIZ];
	auto	NOSIGN	nc = 0;
	auto	NOSIGN	found = 0;
/*
	check name list(s) if any first
*/
	rewind(lfp);	/* rewind the list */
	while(found == 0 && fgets(ls,NAMSIZ-1,lfp))	{
		nc += 1;
		strcnd(ls);			/* trash the line feed(s) */
		if(samename(f_name,ls))	found = 1;
		}
	if(nc == 0)	found = 1;	/* null list */
	if(oswitch.usenewr && found == 1)	found = arcnewer(f_name,phstat);
	else
	if(oswitch.usegenr && found == 1)	found = arcgener(f_name,phstat);
	if(found)	takefile(f_name);
	return(found);
}
samename(os,is)
char	*os;	/* file name */
char	*is;	/* target pattern*/
{
	register	char	*osx = os;
	register	char	*isx = is;
#ifdef	DEBUG
	fprintf(stderr,"samename(%s,%s)\n",osx,isx);
#endif
	while(*isx != 0 && tolower(*osx) == tolower(*isx))	++osx, ++isx;
#ifdef	DEBUG
	fprintf(stderr,"samename(%s,%s)\n",osx,isx);
#endif
	if(*isx == 0)	return(1);
	else			return(0);
}
void
takefile(is)	/* record file as accepted */
char	*is;
{
	fprintf(xfp,"%s\n",is);
	return;
}
