/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define			MAXBLK		40
#define			MAXDSK		720
/*EXTERN*/
extern	int		rd_blk();
extern	int		wr_blk();
/*GLOBAL*/
KENV	kenv;
/*STATIC*/
static	char	*wr_mode;
static	char	*rd_mode;
static	int		(*func)();
static	long	nbi = 0L;
static	long	nbo = 0L;
static	NOSIGN	cpb;					/* chars per block */
static	char	buf[BLKSIZ * MAXBLK];	/* super buffer */
static	int		nci;					/* characters input */
static	int		nco;					/* characters output */
static	NOSIGN	bpd;					/* blocks per disk */
static	FILE	*ifp;
static	FILE	*ofp;
static	char	*ifn;
static	char	*ofn;
static	char	*hx[] = {
	"=blocker [-options] [-]",
	"*",
	"*        spread an archive over multiple floppies",
	"*        consolidate an archive from multiple floppies",
	"*",
	"=",
	"-a       append if -o given",
	"-bNNNN   blocks are NNNN chars [512]",
	"-fNNNN   floppy holds NNNN blocks [720]",
	"-i name  input file is name [stdin]",
	"-o name  output file is name [stdout]",
	"-r       read from floppies",
	"-w       write to floppies",
	"-A       set b and f for 360  k floppies",
	"-B       set b and f for 720  k floppies",
	"-C       set b and f for 1200 k floppies",
	"=",
	}	;
hint(fp)
FILE	*fp;
{
	prhint(hx,sizeof(hx)/sizeof(char *),ZERO,NULL);
	if(fp == stdout)	exit(0);
	else				exit(FUBAR);
	return(0);
}
void
terror(ty)
int		ty;
{
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "blocker");
	if(cmdnum(argc,argv,'h',0,DA))	hint(stdout);
	if(cmdnum(argc,argv,'r',0,DA))	func = rd_blk;
	if(cmdnum(argc,argv,'w',0,DA))	func = wr_blk;
	if(func == (FUNCP) NULL)		hint(stderr);
	if(kenv.dosdos)	{
		wr_mode = "wb";
		rd_mode = "rb";
		}
	else	{
		wr_mode = "w";
		rd_mode = "r";
		}
	ifn = cmdstr(argc,argv,'i',NULL);
	ofn = cmdstr(argc,argv,'o',NULL);
	if(cmdnum(argc,argv,'a',0,DA))	wr_mode[0] = 'a';
	if(ofn)	ofp = freopen(ofn,wr_mode,stdout);
	else	ofp = stdout;
	if(!ofp)	{
		perror(ofn);
		exit(FUBAR);
		}
	if(ifn)	ifp = freopen(ifn,rd_mode,stdin);
	else	ifp = stdin;
	if(!ifp)	{
		perror(ifn);
		exit(FUBAR);
		}
	cpb = cmdnum(argc,argv,'b',BLKSIZ,BLKSIZ);
	bpd = cmdnum(argc,argv,'f',MAXDSK,MAXDSK);
	if(cmdnum(argc,argv,'C',0,DA))	{
		cpb = 5120; bpd = 240;
		}
	if(cmdnum(argc,argv,'B',0,DA))	{
		cpb = 5120; bpd = 144;
		}
	if(cmdnum(argc,argv,'A',0,DA))	{
		cpb = 5120; bpd = 72;
		}
	(*func)(ofp,ifp);
	exit(0);
}
rd_blk(ofp,ifp)
FILE	*ofp;
FILE	*ifp;
{
	while(!feof(ifp))	{
#ifdef	DEBUG
	fprintf(stderr,"rd_blk: nbi %4ld bpd %4u cpb %4u\n",nbi,bpd,cpb);
#endif
		if(nbi % bpd == 0)	{
			fclose(ifp);
			if(query(stderr) == 'q')	{
				fclose(ifp);
				continue;
				}
			ifp = freopen(ifn,rd_mode,stdin);
			if(!ifp)	{
				prterr("rd_blk: '%s'",ifn);
				exit(FUBAR);
				}
			}
		nci = fread(buf,sizeof(char),cpb,ifp);
		if(nci == 0)		break;
		else
		if(nci < 0)			{
			prterr("rd_blk: '%s'",ifn);
			exit(FUBAR);
			}
		nbi += 1;
		nco = fwrite(buf,sizeof(char),nci,ofp);
		if(nco != nci)		{
			prterr("rd_blk: '%s'",ofn);
			exit(FUBAR);
			}
		nbo += 1;
		}
	return;
}
wr_blk(ofp,ifp)
FILE	*ofp;
FILE	*ifp;
{
	while(!feof(ifp))	{
#ifdef	DEBUG
	fprintf(stderr,"wr_blk: nbi %4ld bpd %4u cpb %4u\n",nbi,bpd,cpb);
#endif
		nci = fread(buf,sizeof(char),cpb,ifp);
		if(nci == 0)		break;
		else
		if(nci < 0)			{
			prterr("wr_blk: '%s'",ifn);
			exit(FUBAR);
			}
		nbi += 1;
		if(nbo % bpd == 0)	{
			fclose(ofp);
			if(query(stderr) == 'q')	{
				fclose(ifp);
				continue;
				}
			ofp = freopen(ofn,wr_mode,stdout);
			if(!ofp)	{
				prterr("wr_blk: '%s'",ofn);
				exit(FUBAR);
				}
			}
		nco = fwrite(buf,sizeof(char),nci,ofp);
		if(nco != nci)		{
			prterr("wr_blk: '%s'",ofn);
			exit(FUBAR);
			}
		nbo += 1;
		}
	return;
}
padlast(ofp,nc)
FILE	*ofp;
int		nc;
{
	while(nc-- >= 1)	putc(ZERO,ofp);
	return;
}
